import { NonEmptyArray, PredIndexed } from './_types';
/**
 * Splits a collection into sets, grouped by the result of running each value through `fn`.
 * @param items the items to group
 * @param fn the grouping function
 * @signature
 *    R.groupBy(array, fn)
 * @example
 *    R.groupBy(['one', 'two', 'three'], x => x.length) // => {3: ['one', 'two'], 5: ['three']}
 * @data_first
 * @indexed
 * @category Array
 */
export declare function groupBy<Item, Key extends PropertyKey>(items: readonly Item[], fn: (item: Item) => Key): Partial<Record<Key, NonEmptyArray<Item>>>;
export declare function groupBy<Item, Key extends PropertyKey>(fn: (item: Item) => Key): (array: readonly Item[]) => Partial<Record<Key, NonEmptyArray<Item>>>;
export declare namespace groupBy {
    function indexed<Item, Key extends PropertyKey>(array: readonly Item[], fn: PredIndexed<Item, Key>): Partial<Record<Key, NonEmptyArray<Item>>>;
    function indexed<Item, Key extends PropertyKey>(fn: PredIndexed<Item, Key>): (array: readonly Item[]) => Partial<Record<Key, NonEmptyArray<Item>>>;
}
//# sourceMappingURL=groupBy.d.ts.map