"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var uniq_1 = require("./uniq");
var pipe_1 = require("./pipe");
var _counter_1 = require("./_counter");
var take_1 = require("./take");
it('uniq', function () {
    expect((0, uniq_1.uniq)([1, 2, 2, 5, 1, 6, 7])).toEqual([1, 2, 5, 6, 7]);
});
describe('pipe', function () {
    it('uniq', function () {
        var counter = (0, _counter_1.createCounter)();
        var result = (0, pipe_1.pipe)([1, 2, 2, 5, 1, 6, 7], counter.fn(), (0, uniq_1.uniq)(), (0, take_1.take)(3));
        expect(counter.count).toHaveBeenCalledTimes(4);
        expect(result).toEqual([1, 2, 5]);
    });
    it('take before uniq', function () {
        // bug from https://github.com/remeda/remeda/issues/14
        var counter = (0, _counter_1.createCounter)();
        var result = (0, pipe_1.pipe)([1, 2, 2, 5, 1, 6, 7], counter.fn(), (0, take_1.take)(3), (0, uniq_1.uniq)());
        expect(counter.count).toHaveBeenCalledTimes(3);
        expect(result).toEqual([1, 2]);
    });
});
